EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CLOCK_EVENT_CHANGED =
   EFL_EVENT_DESCRIPTION("changed");

void _efl_ui_clock_format_set(Eo *obj, Efl_Ui_Clock_Data *pd, const char *fmt);


static Eina_Error
__eolian_efl_ui_clock_format_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_clock_format_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_format_set, EFL_FUNC_CALL(fmt), const char *fmt);

const char *_efl_ui_clock_format_get(const Eo *obj, Efl_Ui_Clock_Data *pd);


static Eina_Value
__eolian_efl_ui_clock_format_get_reflect(const Eo *obj)
{
   const char *val = efl_ui_clock_format_get(obj);
   return eina_value_string_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_format_get, const char *, NULL);

void _efl_ui_clock_pause_set(Eo *obj, Efl_Ui_Clock_Data *pd, Eina_Bool paused);


static Eina_Error
__eolian_efl_ui_clock_pause_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_clock_pause_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_pause_set, EFL_FUNC_CALL(paused), Eina_Bool paused);

Eina_Bool _efl_ui_clock_pause_get(const Eo *obj, Efl_Ui_Clock_Data *pd);


static Eina_Value
__eolian_efl_ui_clock_pause_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_clock_pause_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_pause_get, Eina_Bool, 0);

void _efl_ui_clock_edit_mode_set(Eo *obj, Efl_Ui_Clock_Data *pd, Eina_Bool value);


static Eina_Error
__eolian_efl_ui_clock_edit_mode_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_clock_edit_mode_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_edit_mode_set, EFL_FUNC_CALL(value), Eina_Bool value);

Eina_Bool _efl_ui_clock_edit_mode_get(const Eo *obj, Efl_Ui_Clock_Data *pd);


static Eina_Value
__eolian_efl_ui_clock_edit_mode_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_clock_edit_mode_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_edit_mode_get, Eina_Bool, 0);

void _efl_ui_clock_time_min_set(Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Time mintime);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_time_min_set, EFL_FUNC_CALL(mintime), Efl_Time mintime);

Efl_Time _efl_ui_clock_time_min_get(const Eo *obj, Efl_Ui_Clock_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_time_min_get, Efl_Time, ((Efl_Time){0}));

void _efl_ui_clock_time_max_set(Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Time maxtime);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_time_max_set, EFL_FUNC_CALL(maxtime), Efl_Time maxtime);

Efl_Time _efl_ui_clock_time_max_get(const Eo *obj, Efl_Ui_Clock_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_time_max_get, Efl_Time, ((Efl_Time){0}));

void _efl_ui_clock_time_set(Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Time curtime);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_time_set, EFL_FUNC_CALL(curtime), Efl_Time curtime);

Efl_Time _efl_ui_clock_time_get(const Eo *obj, Efl_Ui_Clock_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_clock_time_get, Efl_Time, ((Efl_Time){0}));

void _efl_ui_clock_field_visible_set(Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Ui_Clock_Type fieldtype, Eina_Bool visible);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_field_visible_set, EFL_FUNC_CALL(fieldtype, visible), Efl_Ui_Clock_Type fieldtype, Eina_Bool visible);

Eina_Bool _efl_ui_clock_field_visible_get(const Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Ui_Clock_Type fieldtype);

EAPI EAPI_WEAK EFL_FUNC_BODYV_CONST(efl_ui_clock_field_visible_get, Eina_Bool, 0, EFL_FUNC_CALL(fieldtype), Efl_Ui_Clock_Type fieldtype);

void _efl_ui_clock_field_limit_set(Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Ui_Clock_Type fieldtype, int min, int max);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_clock_field_limit_set, EFL_FUNC_CALL(fieldtype, min, max), Efl_Ui_Clock_Type fieldtype, int min, int max);

void _efl_ui_clock_field_limit_get(const Eo *obj, Efl_Ui_Clock_Data *pd, Efl_Ui_Clock_Type fieldtype, int *min, int *max);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_clock_field_limit_get, EFL_FUNC_CALL(fieldtype, min, max), Efl_Ui_Clock_Type fieldtype, int *min, int *max);

Efl_Object *_efl_ui_clock_efl_object_constructor(Eo *obj, Efl_Ui_Clock_Data *pd);


void _efl_ui_clock_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Clock_Data *pd);


Eina_Error _efl_ui_clock_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Clock_Data *pd);


void _efl_ui_clock_efl_ui_l10n_translation_update(Eo *obj, Efl_Ui_Clock_Data *pd);


static Eina_Bool
_efl_ui_clock_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_CLOCK_EXTRA_OPS
#define EFL_UI_CLOCK_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_clock_format_set, _efl_ui_clock_format_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_format_get, _efl_ui_clock_format_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_pause_set, _efl_ui_clock_pause_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_pause_get, _efl_ui_clock_pause_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_edit_mode_set, _efl_ui_clock_edit_mode_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_edit_mode_get, _efl_ui_clock_edit_mode_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_min_set, _efl_ui_clock_time_min_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_min_get, _efl_ui_clock_time_min_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_max_set, _efl_ui_clock_time_max_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_max_get, _efl_ui_clock_time_max_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_set, _efl_ui_clock_time_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_time_get, _efl_ui_clock_time_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_field_visible_set, _efl_ui_clock_field_visible_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_field_visible_get, _efl_ui_clock_field_visible_get),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_field_limit_set, _efl_ui_clock_field_limit_set),
      EFL_OBJECT_OP_FUNC(efl_ui_clock_field_limit_get, _efl_ui_clock_field_limit_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_clock_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_clock_efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_clock_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_l10n_translation_update, _efl_ui_clock_efl_ui_l10n_translation_update),
      EFL_UI_CLOCK_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"format", __eolian_efl_ui_clock_format_set_reflect, __eolian_efl_ui_clock_format_get_reflect},
      {"pause", __eolian_efl_ui_clock_pause_set_reflect, __eolian_efl_ui_clock_pause_get_reflect},
      {"edit_mode", __eolian_efl_ui_clock_edit_mode_set_reflect, __eolian_efl_ui_clock_edit_mode_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_clock_class_desc = {
   EO_VERSION,
   "Efl.Ui.Clock",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Clock_Data),
   _efl_ui_clock_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_clock_class_get, &_efl_ui_clock_class_desc, EFL_UI_LAYOUT_BASE_CLASS, NULL);
